﻿using System;
using System.Collections.Generic;
using System.Text;

namespace BeeDevelopment.BbcBasicEditor {
	public class BbcBasicEncoding : Encoding {

		public override int GetByteCount(char[] chars, int index, int count) {
			return count - index;
		}

		public override int GetBytes(char[] chars, int charIndex, int charCount, byte[] bytes, int byteIndex) {
			for (int i = charIndex, j = byteIndex; i < charIndex + charCount; ++i, ++j) {
				bytes[j] = CharToByte(chars[i]);
			}
			return charCount;
		}

		public static byte CharToByte(char c) {
			switch (c) {
				case '£':
					return 0x60;
				case '`':
					return (byte)'\'';
				default:
					if (c >= 0 && c <= 127) {
						return (byte)c;
					} else {
						return (byte)'?';
					}
			}
		}

		public override int GetCharCount(byte[] bytes, int index, int count) {
			return count;
		}

		public override int GetChars(byte[] bytes, int byteIndex, int byteCount, char[] chars, int charIndex) {
			for (int i = byteIndex, j = charIndex; i < byteIndex + byteCount; ++i, ++j) {
				switch (bytes[i]) {
					case 0x60:
						chars[j] = '£';
						break;
					default:
						if (bytes[i] >= 0 && bytes[i] <= 127) {
							chars[j] = (char)bytes[i];
						} else {
							chars[j] = '?';
						}
						break;
				}
			}
			return byteCount;
		}

		public override int GetMaxByteCount(int charCount) {
			return charCount;
		}

		public override int GetMaxCharCount(int byteCount) {
			return byteCount;
		}
	}
}
