﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;

namespace BeeDevelopment.BbcBasicEditor.Wpf {
	/// <summary>
	/// Implements a converter between TextWrapping and bool.
	/// </summary>
	[ValueConversion(typeof(TextWrapping), typeof(bool))]
	public class TextWrappingConverter : IValueConverter {
		public object Convert(object value, Type targetType, object parameter, CultureInfo culture) {
			return ((TextWrapping)value) != TextWrapping.NoWrap;
		}
		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture) {
			return ((bool)value) ? TextWrapping.Wrap : TextWrapping.NoWrap;
		}
	}
}